/****************************************************************************
*
*   Copyright (c) 2007 www.societyofrobots.com
*   (please link back if you use this code!)
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License version 2 as
*   published by the Free Software Foundation.
*
*   Alternatively, this software may be distributed under the terms of BSD
*   license.
*
*	CMUcam Interface Software, June 24th, 2007
*
*
****************************************************************************/

//void send_command_ack( char *command );
//void send_command( char *command );
//void process_track( void );

// Globals:
int mx=0;
int my=0;
int x1=0;
int y1=0;
int x2=0;
int y2=0;
int pixels=0;
int conf=0;

// Send data packet.
// Input: robot , then value
// Output: a packet on the uart

// Output string
char tmp_str[64];

void send_command_ack(char *command)
{
	int i;
	int tmp;
	tmp = 0;

	// Dump all the letters to the queue
	for ( i = 0 ; i < 64 && command[i] != 0 ; i++ )
		uart_putc( command[i] ); // Add each letter to the queue

	// Add a new line to tell the camera to accept it
	uart_putc( '\r' ); // newline
	//	uart_putc( '\n' ); // newline

	i = 0;
	memset( tmp_str , 0 , 64 );

	while ( tmp != ':' )
		{
		tmp = uart_getc();
		if ( tmp != UART_NO_DATA )
			{
			tmp_str[i++] = (char) tmp;
			}
		}
}


// send command in raw mode, don't wait for a result.
void send_command(char *command)
	{
	int i;

	// Dump all the letters to the queue
	for ( i = 0 ; i < 64 && command[i] != 0 ; i++ )
		uart_putc( command[i] ); // Add each letter to the queue

	// Add a new line to tell the camera to accept it
	uart_putc( '\r' ); // newline
	}


// Read in the data, if good set LED
void process_track(void)
	{
	int tmp= 0;

	// Wait for the first character to be 255
	while ( tmp != 255 )
		tmp = uart_getc();

	tmp = UART_NO_DATA;

	// Grab the next character
	while ( tmp == UART_NO_DATA )
		tmp = uart_getc();

	// Good / Bad ?
	if ( tmp == 'M' )
		{
		while ( mx == UART_NO_DATA ) mx = uart_getc();
		while ( my == UART_NO_DATA ) my = uart_getc();
		while ( x1 == UART_NO_DATA ) x1 = uart_getc();
		while ( y1 == UART_NO_DATA ) y1 = uart_getc();
		while ( x2 == UART_NO_DATA ) x2 = uart_getc();
		while ( y2 == UART_NO_DATA ) y2 = uart_getc();
		while ( pixels == UART_NO_DATA ) pixels = uart_getc();
		while ( conf == UART_NO_DATA ) conf = uart_getc();
		}
	}


void CMUcam_init(void)
	{
	uart_init( UART_BAUD_SELECT(UART_BAUD_RATE,XTAL_CPU) );

	// Init the camera
	send_command_ack( "RM 0" );		// Default raw mode
	send_command_ack( "MM 1" );		// Middle Mass on
	send_command_ack( "PM 0" );		// Poll mode
	send_command_ack( "SW 1 1 80 143" );	// Window

	// Switch modes
	send_command( "RM 3" );		// Return raw data, Remove the ack/nak

	// Setup the camera
	send_command( "TC 200 241 20 100 16 18" );
	}
