/****************************************************************************
*
*   Copyright (c) 2008 www.societyofrobots.com
*   (please link back if you use this code!)
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License version 2 as
*   published by the Free Software Foundation.
*
*   Alternatively, this software may be distributed under the terms of BSD
*   license.
*
****************************************************************************/

//on all servos: go up for clockwise
	int temp;
	int temp2;

//***************ROBOT ARM***************
void arm_left_fold(void)
	{
	arm_left_base(735);//1100 far cw, 740 centered
	arm_left_J1(1120);
	arm_left_J2(1100);//350, but using diff angle for now with crooked servo
	arm_left_claw(900);//higher to close, lower to open (900 mid closed, 600 open)
	}
void arm_right_fold(void)
	{
	arm_right_base(620);
	arm_right_J1(360);//190
	arm_right_J2(350);//700 is straight with J1
	arm_right_claw(550);//lower to close, higher to open (600 mid closed, 950 open)
	}
void claw_open(void)
	{
	arm_left_claw(400);
	arm_right_claw(950);
	}
void claw_close(void)
	{
	arm_left_claw(950);
	arm_right_claw(400);
	}
void claw_mid(void)
	{
	arm_left_claw(550);
	arm_right_claw(550);
	}
//***************************************

//**************ROBOT WHEELS*************

void robot_turn_left(void)
	{
	wheel_left(1115);
	wheel_right(1113);
	}
void robot_turn_right(void)
	{
	wheel_left(415);
	wheel_right(413);
	}
void robot_go_straight(void)
	{
	wheel_left(415);
	wheel_right(1113);
	}
void robot_go_reverse(void)
	{
	wheel_left(1115);
	wheel_right(413);
	}
void hold_position(void)
	{
	wheel_left(715);
	wheel_right(713);
	}
//***************************************


//**************ROBOT CAMERA*************
void cam_straight(void)
	{
	camera_hor(730);//730 is middle
	camera_ver(990);//990 straight, 800 for mobot, 450 down
	}
//***************************************


//*********DEMONSTRATION PROGRAMS********
void throw_ball_step1(void)
	{
	arm_right_base(650);
	arm_right_J1(360);
	arm_right_J2(750);//almost straight with J1
	arm_right_claw(650);//grab ball
	}
void throw_ball_step2(void)
	{
	arm_right_base(650);
	arm_right_J1(800);
	arm_right_J2(500);//700 is straight with J1
	arm_right_claw(950);//open close
	}
void claw_attack(void)
	{
	//rotate body 45 degrees
	for(temp=0;temp<8;temp++)
		{
		//robot_turn_left();
		camera_hor(900);
		camera_ver(1030);
		delay_cycles(5000);
		}

	//stretch arm out
	for(temp=0;temp<40;temp++)
		{
		arm_right_base(850);
		arm_right_J1(1000);
		arm_right_J2(1150);
		delay_cycles(5000);
		}

	//claw for a few seconds
	for(temp=0;temp<10;temp++)
		{
		for(temp2=0;temp2<10;temp2++)
			{
			claw_open();
			delay_cycles(6000);
			}
		for(temp2=0;temp2<10;temp2++)
			{
			claw_close();
			delay_cycles(6000);
			}
		}

	//bring arm back
	for(temp=0;temp<40;temp++)
		{
		arm_right_fold();
		delay_cycles(5000);
		}

	//rotate body back 45 degrees
	for(temp=0;temp<8;temp++)
		{
		//robot_turn_right();
		cam_straight();
		delay_cycles(5000);
		}
	}
void wai(void)
	{
	camera_hor(780);
	camera_ver(900);
	arm_left_base(900);//1100 far cw, 740 centered
	arm_left_J1(360);
	arm_left_J2(960);
	arm_right_base(500);
	arm_right_J1(1120);
	arm_right_J2(360);//700 is straight with J1
	arm_right_claw(550);//lower to close, higher to open (550 mid closed, 950 open)
	}
void line_backer(void)
	{
	camera_hor(730);
	camera_ver(1100);
	arm_left_base(850);//1100 far cw, 740 centered
	arm_left_J1(460);
	arm_left_J2(860);
	arm_right_base(500);
	arm_right_J1(1120);
	arm_right_J2(360);//700 is straight with J1
	arm_right_claw(550);//lower to close, higher to open (550 mid closed, 950 open)
	}
void fold_for_mobot(void)
	{
	arm_left_fold();
	arm_right_fold();
	cam_straight();
	}
void cover_face(void)
	{
	for(temp=0;temp<8;temp++)
		{
		arm_left_base(1000);
		arm_left_J1(800);
		arm_left_J2(410);
		arm_right_base(500);
		arm_right_J1(600);
		arm_right_J2(965);
		arm_right_claw(500);
		delay_ms(20);
		}
	}
void chicken_dance_forward(void)
	{
	arm_left_base(1000);
	arm_left_J1(900);
	arm_left_J2(965);
	arm_right_base(500);
	arm_right_J1(500);
	arm_right_J2(410);
	arm_right_claw(500);
	}
void chicken_dance_back(void)
	{
	arm_left_base(700);
	arm_left_J1(900);
	arm_left_J2(965);
	arm_right_base(800);
	arm_right_J1(500);
	arm_right_J2(410);
	arm_right_claw(500);
	}
void chicken_dance(void)
	{
	for(temp=0;temp<3;temp++)
		{
		for(temp2=0;temp2<25;temp2++)
			{
			chicken_dance_forward();
			delay_cycles(6000);
			}
		for(temp2=0;temp2<25;temp2++)
			{
			chicken_dance_back();
			delay_cycles(6000);
			}
		}
	}
void cheer_up(void)
	{
	arm_left_base(900);
	arm_left_J1(900);
	arm_left_J2(965);
	arm_right_base(500);
	arm_right_J1(500);
	arm_right_J2(410);
	arm_right_claw(500);
	}
void cheer_down(void)
	{
	arm_left_base(1000);
	arm_left_J1(1120);
	arm_left_J2(965);
	arm_right_base(500);
	arm_right_J1(360);
	arm_right_J2(410);
	arm_right_claw(500);
	}
void cheer(void)
	{
	for(temp=0;temp<2;temp++)
		{
		for(temp2=0;temp2<25;temp2++)
			{
			cheer_up();
			delay_cycles(6000);
			}
		for(temp2=0;temp2<25;temp2++)
			{
			cheer_down();
			delay_cycles(6000);
			}
		}
	}

//***************************************


/*
//***********SPECIAL FUNCTIONS***********
void prepare_for_scan(void)
	{
	for(i=16;i>0;i--)
			{
			arm_fold();
			camera_hor(cam_far_clockwise);
			camera_ver(30);
			delay_cycles(1000);
			}
	}

//arm points in direction to move
void point_direction(int angle)
	{
	if(angle!=0)//direction chosen
		{
		//rotate arm wrt alpha
		for(i=0;i<30;i++)
			{
			arm_left_base(angle);
			//arm_J2(11);
			//arm_J3(45);
			delay_cycles(1300);
			}
		}
	else//no solution available
		arm_fold();
	}
//***************************************


//*********DEMONSTRATION PROGRAMS*********
void demonstrate_drive(void)
	{
	//demonstration program
	for(i=30;i>0;i--)
		{
		arm_fold();
		cam_straight();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_go_straight();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_turn_left();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_go_straight();
		camera_hor(25);
		arm_left_base(45);
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_turn_left();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_go_straight();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_turn_left();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_go_straight();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_turn_left();
		delay_cycles(1300);
		}
	}

void demonstrate_arm(void)
	{
	for(i=30;i>0;i--)
		{
		arm_fold();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		arm_horizontal();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		arm_fold();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		arm_reach_up();
		delay_cycles(1300);
		}
	}
void hand_wave(void)
	{
	for(i=20;i>0;i--)
		{
		arm_vertical();
		delay_cycles(1300);
		}
	for(i=15;i>0;i--)
		{
		arm_J3(20);
		delay_cycles(1300);
		}	
	}

void look_at_object(void)
	{
	arm_left_base(65);
	arm_J2(40);
	arm_J3(13);
	camera_hor(38);
	camera_ver(40);
	}

void stab(void)
	{
	for (i=100;i>=55;i--)
		{
		arm_J2(cos_SoR(i)/2+11);
		arm_J3(cos_SoR(145-i)/2+20);
		delay_cycles(300);
		}
	}
//***************************************


void arm_track(int target_X, int target_Y, int rangefinder)
	{
	//CMUcam and AVRcam have 80(Y) x 143(X) resolution
	//servo goes between about 25 and 55

	//for X axis === cam angle also affects this, so it needs to compensate (not yet done)
	arm_left_base(target_X/3+25);//matches J1 with the target X coordinate

	//Y and Z axis (deepness and height) affects both J2 and J3
	//arm_J2(target_Y/3+11+rangefinder/7);//increase goes up, if depth is close, I want arm to go up
	arm_J3(target_Y/4+35-rangefinder/7);//increase goes up

	//perhaps I should use forward kinematics and if statements? potential problems . . .
	}


*/
