/****************************************************************************
*
*   Copyright (c) 2007 www.societyofrobots.com
*   (please link back if you use this code!)
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License version 2 as
*   published by the Free Software Foundation.
*
*   Alternatively, this software may be distributed under the terms of BSD
*   license.
*
*	ERP Motion Lists, June 19th, 2007
*
****************************************************************************/


int i=0;//stuff variable
int j=0;//stuff variable


//cam position
int camera_hor_angle=0;
int camera_ver_angle=0;
int cam_far_clockwise=67;//68 with camera (away from robot, higher goes further)
int cam_far_counterc=32;//22 (towards robot, lower goes closer)
int cam_far_up=40;
int cam_far_down=24;
int cam_vert_scan_divisor=4;



//***************ROBOT ARM***************
void arm_fold(void)
	{
	arm_left_base(20);
	arm_J2(42);
	arm_J3(75);
	}
void arm_horizontal(void)
	{
	arm_left_base(45);
	arm_J2(11);
	arm_J3(45);
	}
void arm_reach_up(void)
	{
	arm_left_base(45);
	arm_J2(35);
	arm_J3(35);
	}
void arm_vertical(void)
	{
	arm_left_base(45);
	arm_J2(42);
	arm_J3(45);
	}
//***************************************

//**************ROBOT WHEELS*************

void robot_turn_left(void)
	{
	wheel_left=500;
	wheel_right=500;
	}
void robot_turn_right(void)
	{
	wheel_left=700;
	wheel_right=700;
	}
void robot_go_straight(void)
	{
	wheel_left=500;
	wheel_right=700;
	}
void robot_go_reverse(void)
	{
	wheel_left=700;
	wheel_right=500;
	}
void hold_position(void)
	{
	wheel_left=600;
	wheel_right=600;
	}
//***************************************


//**************ROBOT CAMERA*************
void cam_straight(void)
	{
	camera_hor(500);
	camera_ver(500);
	}
//***************************************


//***********SPECIAL FUNCTIONS***********
void prepare_for_scan(void)
	{
	for(i=16;i>0;i--)
			{
			arm_fold();
			camera_hor(cam_far_clockwise);
			camera_ver(30);
			delay_cycles(1000);
			}
	}

//arm points in direction to move
void point_direction(int angle)
	{
	if(angle!=0)//direction chosen
		{
		//rotate arm wrt alpha
		for(i=0;i<30;i++)
			{
			arm_left_base(angle);
			//arm_J2(11);
			//arm_J3(45);
			delay_cycles(1300);
			}
		}
	else//no solution available
		arm_fold();
	}
//***************************************


//*********DEMONSTRATION PROGRAMS*********
void demonstrate_drive(void)
	{
	//demonstration program
	for(i=30;i>0;i--)
		{
		arm_fold();
		cam_straight();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_go_straight();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_turn_left();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_go_straight();
		camera_hor(25);
		arm_left_base(45);
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_turn_left();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_go_straight();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_turn_left();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_go_straight();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		robot_turn_left();
		delay_cycles(1300);
		}
	}

void demonstrate_arm(void)
	{
	for(i=30;i>0;i--)
		{
		arm_fold();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		arm_horizontal();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		arm_fold();
		delay_cycles(1300);
		}
	for(i=30;i>0;i--)
		{
		arm_reach_up();
		delay_cycles(1300);
		}
	}
void hand_wave(void)
	{
	for(i=20;i>0;i--)
		{
		arm_vertical();
		delay_cycles(1300);
		}
	for(i=15;i>0;i--)
		{
		arm_J3(20);
		delay_cycles(1300);
		}	
	}

void look_at_object(void)
	{
	arm_left_base(65);
	arm_J2(40);
	arm_J3(13);
	camera_hor(38);
	camera_ver(40);
	}

void stab(void)
	{
	for (i=100;i>=55;i--)
		{
		arm_J2(cos_SoR(i)/2+11);
		arm_J3(cos_SoR(145-i)/2+20);
		delay_cycles(300);
		}
	}
//***************************************


void arm_track(int target_X, int target_Y, int rangefinder)
	{
	//CMUcam and AVRcam have 80(Y) x 143(X) resolution
	//servo goes between about 25 and 55

	//for X axis === cam angle also affects this, so it needs to compensate (not yet done)
	arm_left_base(target_X/3+25);//matches J1 with the target X coordinate

	//Y and Z axis (deepness and height) affects both J2 and J3
	//arm_J2(target_Y/3+11+rangefinder/7);//increase goes up, if depth is close, I want arm to go up
	arm_J3(target_Y/4+35-rangefinder/7);//increase goes up

	//perhaps I should use forward kinematics and if statements? potential problems . . .
	}


